/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ShapeSeriesBase } from "./ShapeSeriesBase";
import { ShapeAxisInfoCache } from "./ShapeAxisInfoCache";
import { StyleSelector } from "./StyleSelector";
import { DependencyProperty } from "igniteui-react-core";
import { Style } from "igniteui-react-core";
import { MarkerType_$type } from "./MarkerType";
import { DataTemplate } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { CollisionAvoidanceType_$type } from "./CollisionAvoidanceType";
import { MarkerOutlineMode_$type } from "./MarkerOutlineMode";
import { MarkerFillMode_$type } from "./MarkerFillMode";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { Base, runOn, enumGetBox, Number_$type, typeCast, fromEnum, markType, markDep, PointUtil } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { ShapeSeriesViewBase } from "./ShapeSeriesViewBase";
import { Marker } from "./Marker";
import { MarkerSeries } from "./MarkerSeries";
import { BrushUtil } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { HashPool$2 } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { RectUtil } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { isNaN_, isInfinity } from "igniteui-react-core";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { DataTemplateMeasureInfo } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { Defaults } from "./Defaults";
import { DataTemplatePassInfo } from "igniteui-react-core";
import { DataTemplateRenderInfo } from "igniteui-react-core";
import { MarkerVisualData } from "./MarkerVisualData";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
export let ScatterPolygonSeries = /*@__PURE__*/ (() => {
    class ScatterPolygonSeries extends ShapeSeriesBase {
        get_e3() {
            return true;
        }
        get_ey() {
            return true;
        }
        constructor() {
            super();
            this.w6 = null;
            this.w3 = new ScalerParams(1, ScatterPolygonSeries.yc, ScatterPolygonSeries.yc, false);
            this.w4 = new ScalerParams(1, ScatterPolygonSeries.yc, ScatterPolygonSeries.yc, false);
            this.xs = null;
            this.wy = 1;
            this.wu = 1;
            this.ab = ScatterPolygonSeries.$;
        }
        u9() {
            return this.w8();
        }
        wb(a) {
            let b = a;
            b.cy(this.ye);
            b.cz(this.w7);
            super.wb(a);
            if (this.dl(a)) {
                return;
            }
            let c, d;
            let e = a.getViewInfo(c, d);
            c = e.p0;
            d = e.p1;
            let f = this.getEffectiveViewport1(a);
            this.w3 = new ScalerParams(1, d, c, this.ui.ch);
            this.w3.c = f;
            this.w4 = new ScalerParams(1, d, c, this.uk.ch);
            this.w4.c = f;
            if (c.width < 1 || c.height < 1) {
                return;
            }
            this.w6 = ((() => {
                let $ret = new ShapeAxisInfoCache();
                $ret.a = this.ui;
                $ret.b = this.uk;
                $ret.e = this.ui.ch;
                $ret.f = this.uk.ch;
                $ret.d = this.c6;
                $ret.c = this.us;
                return $ret;
            })());
            if (this.w8()) {
                let g = new Dictionary$2(Base.$, OwnedPoint.$, 0);
                b.dg.l(g, 400, d, c, this.hj);
                b.dg.j(g, false);
                if (this.u7()) {
                    this.xp(a);
                }
            }
        }
        xp(a) {
            a.dk = true;
            this.up.ay(this, this.u7(), runOn(this, this.t7));
            let b = this.up.d;
            let c = b != null;
            let d = this.getEffectiveViewport1(a);
            let e = this.c6 == null ? 0 : this.c6.count;
            a.dw((f) => {
                if (f._visibility == 0) {
                    let g = f.ak;
                    let h = f.content;
                    if (h == null) {
                        h = new DataContext();
                        f.content = h;
                    }
                    if (c) {
                        this.v6(g, e, a.q);
                    }
                    this.up.ac(f, h);
                }
            });
        }
        w8() {
            return this.xs != null && ((this.w2 != 1 && this.w2 != 0) || this.xt != null);
        }
        cg() {
            return new ScatterPolygonSeriesView(this);
        }
        o0(a) {
            super.o0(a);
            this.w5 = a;
        }
        get_hasMarkers() {
            return true;
        }
        sz() {
            return this.x8;
        }
        s0() {
            return this.x9;
        }
        qv() {
            return this.xr;
        }
        kx() {
            return this.ky(this, this.xs);
        }
        hs() {
            return this.xa;
        }
        get wz() {
            return this.wy;
        }
        set wz(a) {
            this.wy = a;
        }
        w1() {
            if (this.w0 == 0) {
                return 1;
            }
            return this.w0;
        }
        qh(a) {
            super.qh(a);
            this.w0 = a;
        }
        get wv() {
            return this.wu;
        }
        set wv(a) {
            this.wu = a;
        }
        wx() {
            if (this.ww == 0) {
                return 2;
            }
            return this.ww;
        }
        qg(a) {
            super.qg(a);
            this.ww = a;
        }
        qi(a) {
            super.qi(a);
            this.xa = a;
        }
        qd() {
            super.qd();
            if (this.index < 0) {
                return;
            }
            if (this.xt != null) {
                this.w5.dv();
                this.w5.ds();
            }
            else {
                let a = MarkerSeries.ub(this, this.w2);
                let b = MarkerSeries.uj(a);
                if (b == null) {
                    this.xr = MarkerSeries.ux;
                }
                else {
                    this.w5.dp(b);
                }
            }
            if (this.ya != null && this.w2 != 13) {
                this.p4("ActualMarkerBrush");
                let c = this.x8;
                this.w5.dt();
                this.w5.dq();
                let d = this.x8;
                let e = this.eu("ActualMarkerBrush", this.g1.f > 0 ? this.g1.d() : null, c, d);
                this.p6("ActualMarkerBrush", e);
            }
            else {
                if (this.w2 == 13) {
                    this.x8 = this.cj.bt();
                }
                else {
                    if (this.wv != 2) {
                        if (this.cy != null) {
                            let f = this.cy.sy(this.index);
                            if (!isNaN_(this.hi) && this.hi != 1) {
                                f = BrushUtil.q(f, this.hi);
                            }
                            this.x8 = f;
                        }
                        else {
                            this.x8 = null;
                        }
                    }
                }
            }
            if (this.yb != null) {
                this.w5.du();
                this.w5.dr();
            }
            else {
                if (this.w2 == 13) {
                    this.x9 = this.cj.bt();
                }
                else {
                    if (this.w0 == 2) {
                        this.x9 = this.x8;
                    }
                    else {
                        this.x9 = this.cy == null ? null : this.cy.sz(this.index);
                    }
                }
            }
            if (this.wv == 2 && this.ya == null && this.w2 != 13) {
                if (this.x9 != null) {
                    let g = this.x9;
                    if (!isNaN_(this.hi) && this.hi != 1) {
                        g = BrushUtil.q(g, this.hi);
                    }
                    this.x8 = g;
                }
                else {
                    this.x8 = null;
                }
            }
        }
        or() {
            super.or();
            this.wz = this.w1();
            this.wv = this.wx();
        }
        o8(a, b, c, d) {
            super.o8(a, b, c, d);
            switch (b) {
                case ScatterPolygonSeries.$$p[3]:
                case ScatterPolygonSeries.$$p[11]:
                case ScatterPolygonSeries.$$p[7]:
                case ScatterPolygonSeries.$$p[9]:
                case ScatterPolygonSeries.$$p[10]:
                    this.pe(b);
                    this.o2();
                    break;
                case ScatterPolygonSeries.$$p[6]:
                    this.wz = this.w1();
                    this.pe(null);
                    this.o2();
                    break;
                case ScatterPolygonSeries.$$p[5]:
                    this.wv = this.wx();
                    this.pe(null);
                    this.o2();
                    break;
                case ScatterPolygonSeries.$$p[2]:
                    this.xs = d;
                    if (c == MarkerSeries.ux || d == MarkerSeries.ux || (c == null || d != null)) {
                        this.w5.dx();
                        this.pp(false);
                    }
                    this.cj.bl();
                    if (this.toolTip != null && this.ev) {
                        this.a7.a$aj(this, this.toolTip);
                    }
                    this.pp(false);
                    this.ol();
                    break;
                case ScatterPolygonSeries.$$p[12]:
                    this.w5.cy(this.ye);
                    this.pp(false);
                    this.ol();
                    break;
                case ScatterPolygonSeries.$$p[13]:
                    this.w5.cz(this.w7);
                    this.pp(false);
                    this.ol();
                    break;
                case ScatterPolygonSeries.$$p[4]:
                    this.pp(false);
                    this.ol();
                    break;
                case ScatterPolygonSeries.$$p[0]:
                case ScatterPolygonSeries.$$p[1]:
                    if (this.w8()) {
                        this.pp(false);
                    }
                    break;
            }
        }
        au(a, b) {
            let c = this.w5.b4(a);
            let d = null;
            if (c != null) {
                d = c.content;
            }
            if (d != null) {
                return d;
            }
            return super.au(a, b);
        }
        xq(a, b) {
            let c = new List$1(Base.$, 0);
            for (let d of fromEnum(b.c)) {
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
            for (let e of fromEnum(c)) {
                b.h(e);
            }
        }
        ds(a, b, c, d) {
            if (!this.hasMarkers) {
                return false;
            }
            let e = this.ui;
            let f = new ScalerParams(1, this.cy.tn, this.tw, e.ch);
            f.c = this.getEffectiveViewport1(this.cj);
            let g = this.uk;
            let h = new ScalerParams(1, this.cy.tn, this.tw, g.ch);
            h.c = this.getEffectiveViewport1(this.cj);
            a.clear();
            this.w5.dw((i) => {
                if (i._visibility == 0) {
                    let j = new SeriesPointOfInterest();
                    let k = i.n;
                    let l = i.o;
                    if (k < this.tw.left || k > this.tw.right || l < this.tw.top || l > this.tw.bottom) {
                        return;
                    }
                    j.b = e.em(k, f);
                    j.c = g.em(l, h);
                    j.a = i.content;
                    a.add(j);
                }
            });
            return true;
        }
        ws(a, b, c, d, e) {
            if (c == null || c.length != this.w6.d.count) {
                c = new Array(this.w6.d.count);
                for (let f = 0; f < this.w6.d.count; f++) {
                    c[f] = PointUtil.create();
                }
            }
            let g = ((() => {
                let $ret = new ScalerParams(1, d, e, this.ui.ch);
                $ret.c = this.getEffectiveViewport1(a);
                return $ret;
            })());
            let h = ((() => {
                let $ret = new ScalerParams(1, d, e, this.uk.ch);
                $ret.c = this.getEffectiveViewport1(a);
                return $ret;
            })());
            let i = this.to(a);
            let j = this.w6.a.em(i.left, g);
            let k = this.w6.a.em(i.right, g);
            let l = this.w6.b.em(i.bottom, h);
            let m = this.w6.b.em(i.top, h);
            if (this.w6.e) {
                let n = j;
                j = k;
                k = n;
            }
            if (this.w6.f) {
                let o = l;
                l = m;
                m = o;
            }
            let p = this.w6;
            let q = p.a;
            let r = p.b;
            let s;
            let t;
            let u = g.d.left;
            let v = g.d.right;
            let w = h.d.top;
            let x = h.d.bottom;
            for (let y = 0; y < this.w6.d.count; y++) {
                s = 0;
                t = 0;
                let z = null;
                let aa = a.cc.tryGetValue(y, z);
                z = aa.p1;
                if (z == null) {
                    c[y].x = NaN;
                    c[y].y = NaN;
                }
                else {
                    let ab = z.c;
                    let ac = RectUtil.l(ab);
                    s = ac.x;
                    t = ac.y;
                    if (s >= u && s <= v && t >= w && t <= x) {
                        c[y].x = s;
                        c[y].y = t;
                    }
                    else {
                        c[y].x = NaN;
                        c[y].y = NaN;
                    }
                }
            }
            return c;
        }
        w9(a, b) {
            if (b == null) {
                b = new List$1(Number_$type, 2, a.e);
            }
            else {
                b.clear();
            }
            let c = 0;
            let d = this.c6;
            for (let e of fromEnum(a.c)) {
                b.add(d.indexOf(e));
                c++;
            }
            return b;
        }
    }
    ScatterPolygonSeries.$t = /*@__PURE__*/ markType(ScatterPolygonSeries, 'ScatterPolygonSeries', ShapeSeriesBase.$);
    ScatterPolygonSeries.yc = /*@__PURE__*/ new Rect(0, 0, 0, 1, 1);
    ScatterPolygonSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, ScatterPolygonSeries, 'raisePropertyChanged', ['ActualMarkerBrush:x8:xu', [Brush.$], 'ActualMarkerOutline:x9:xv', [Brush.$], 'ActualMarkerTemplate:xr:xw', [DataTemplate.$, null], 'MarkerBrush:ya:xx', [Brush.$], 'MarkerCollisionAvoidance:wt:xy', [CollisionAvoidanceType_$type, /*@__PURE__*/ enumGetBox(CollisionAvoidanceType_$type, 0)], 'MarkerFillMode:ww:xz', [MarkerFillMode_$type, /*@__PURE__*/ enumGetBox(MarkerFillMode_$type, 0)], 'MarkerOutlineMode:w0:x0', [MarkerOutlineMode_$type, /*@__PURE__*/ enumGetBox(MarkerOutlineMode_$type, 0)], 'MarkerOutline:yb:x1', [Brush.$], 'MarkerStyle:yd:x2', [Style.$], 'MarkerTemplate:xt:x3', [DataTemplate.$, null], 'MarkerThickness:xa:x4', [1, /*@__PURE__*/ DeviceUtils.g(2)], 'MarkerType:w2:x5', [MarkerType_$type, /*@__PURE__*/ enumGetBox(MarkerType_$type, 1)], 'ShapeStyle:ye:x6', [Style.$, null], 'ShapeStyleSelector:w7:x7', [StyleSelector.$, null]]);
    return ScatterPolygonSeries;
})();
/**
 * @hidden
 */
export let ScatterPolygonSeriesView = /*@__PURE__*/ (() => {
    class ScatterPolygonSeriesView extends ShapeSeriesViewBase {
        constructor(a) {
            super(a);
            this.dk = false;
            this.db = null;
            this.dm = null;
            this.dh = null;
            this.df = null;
            this.dj = false;
            this.di = null;
            this.dn = null;
            this.dc = new Marker();
            this.d4 = null;
            this.dc = new Marker();
            this.dc.content = new DataContext();
            this.dh = a;
            this.di = new HashPool$2(Base.$, Marker.$);
            this.dn = new List$1(Marker.$, 0);
            this.dy(this.di);
            this.df = new NumericMarkerManager(1, (b) => this.di.item(b), (b) => this.dh.w6.d.item(b), runOn(this, this.d2), runOn(this, this.da), runOn(this, this.dl), () => this.dh.wt);
            this.df.q = runOn(this, this.d5);
        }
        au() {
            super.au();
            if (!this.q) {
                this.dh.yb = Defaults.am;
                this.dh.iu = Defaults.z;
                this.dh.xa = Defaults.y;
                this.dh.w2 = Defaults.f;
                this.dh.ww = Defaults.b;
            }
        }
        get dg() {
            return this.df;
        }
        d2(a) {
            this.dh.xq(a, this.di);
        }
        da() {
            this.db = this.dh.ws(this, this.di, this.db, this.by, this.bx);
            return this.db;
        }
        dl() {
            this.dm = this.dh.w9(this.di, this.dm);
            return this.dm;
        }
        c5(a, b) {
            return this.c6(a, b, true);
        }
        cm(a, b, c) {
            super.cm(a, b, c);
            ShapeSeriesViewBase.cl(this, a, b);
        }
        ck(a, b) {
            let c = a;
            if (c == null) {
                return;
            }
            c.an = b;
        }
        dw(a) {
            this.di.f(a);
        }
        dy(a) {
            a.create = runOn(this, this.de);
            a.destroy = runOn(this, this.d0);
            a.activate = runOn(this, this.dz);
            a.disactivate = runOn(this, this.d1);
        }
        de() {
            let a = new Marker();
            if (!this.dj) {
                a.content = ((() => {
                    let $ret = new DataContext();
                    $ret.series = this.e;
                    return $ret;
                })());
            }
            a.ah = this.e.xr;
            this.dn.add(a);
            return a;
        }
        b4(a) {
            let b = this.dd(a, 0);
            if (b == null) {
                b = this.dd(a, 3);
            }
            return b;
        }
        dd(a, b) {
            let c;
            let d;
            let e;
            let f;
            for (let g = this.dn.count - 1; g >= 0; g--) {
                let h = this.dn._inner[g];
                if (h._visibility == 1 || h._opacity == 0) {
                    continue;
                }
                c = (h.m / 2) + b;
                d = (h.l / 2) + b;
                e = h.ai;
                f = h.aj;
                if ((h.n + e) - c <= a.x && (h.n + e) + c >= a.x && (h.o + f) - d <= a.y && (h.o + f) + d >= a.y) {
                    return h;
                }
            }
            return null;
        }
        d0(a) {
            a.content = null;
            this.dn.remove(a);
        }
        dz(a) {
            a._visibility = 0;
        }
        d1(a) {
            if (a.content != null) {
                (typeCast(DataContext.$, a.content)).item = null;
            }
            a._visibility = 1;
        }
        d3(a) {
            this.dj = a;
        }
        bj(a, b) {
            super.bj(a, b);
            if (!this.dk) {
                let c = a;
                let d = c.content;
                if (d != null) {
                    if (this.dh.x8 != null) {
                        d.actualItemBrush = this.dh.x8;
                    }
                    else {
                        d.actualItemBrush = this.b6.ss;
                    }
                    if (this.dh.x8 != null) {
                        d.outline = this.dh.x9;
                    }
                    else {
                        d.outline = this.b6.sv;
                    }
                    d.thickness = this.dh.xa;
                }
            }
        }
        bk(a, b) {
            super.bk(a, b);
            let c = a;
            this.dc._visibility = c._visibility;
            this.dc.ah = c.ah;
            this.dc.width = c.width;
            this.dc.height = c.height;
            this.dc.m = c.m;
            this.dc.l = c.l;
            this.dc.n = c.n;
            this.dc.o = c.o;
            let d = this.bs(b);
            let e = this.dc.content;
            let f = c.content;
            e.item = f.item;
            e.series = f.series;
            e.thickness = f.thickness;
            if (e != null) {
                e.actualItemBrush = d;
                e.outline = d;
                e.thickness = this.dh.xa + 3;
            }
        }
        a7(a, b) {
            super.a7(a, b);
            let c = new DataTemplatePassInfo();
            c.isHitTestRender = b;
            c.context = a.h();
            c.viewportTop = this.bx.top;
            c.viewportLeft = this.bx.left;
            c.viewportWidth = this.bx.width;
            c.viewportHeight = this.bx.height;
            c.passID = "Markers";
            let d = new DataTemplateRenderInfo();
            d.passInfo = c;
            d.isHitTestRender = b;
            let e = new DataTemplateMeasureInfo();
            e.passInfo = c;
            let f = false;
            let g = a.h();
            e.context = g;
            d.context = g;
            let h = 0;
            let i = 0;
            if (this.dh.xr != null && this.dh.xr.passStarting != null) {
                this.dh.xr.passStarting(c);
            }
            for (let j = 0; j < this.dn.count; j++) {
                let k = this.dn._inner[j];
                if (k._visibility == 1) {
                    continue;
                }
                this.bi(k, j, b);
                if (b) {
                    k = this.dc;
                }
                if (!f) {
                    e.width = k.width;
                    e.height = k.height;
                    e.renderOffsetX = 0;
                    e.renderOffsetY = 0;
                    e.renderContext = a;
                    let l = k.ah;
                    if (l.measure != null) {
                        e.data = k.content;
                        l.measure(e);
                        f = e.isConstant;
                        if (f) {
                            h = e.width;
                            i = e.height;
                        }
                    }
                    d.availableWidth = e.width;
                    d.availableHeight = e.height;
                    d.renderOffsetX = e.renderOffsetX;
                    d.renderOffsetY = e.renderOffsetY;
                    d.renderContext = a;
                }
                else {
                    d.availableWidth = h;
                    d.availableHeight = i;
                }
                if (!isNaN_(k.width) && !isInfinity(k.width)) {
                    d.availableWidth = k.width;
                }
                if (!isNaN_(k.height) && !isInfinity(k.height)) {
                    d.availableHeight = k.height;
                }
                a.q(d, k);
                k.m = d.availableWidth;
                k.l = d.availableHeight;
                k.ai = d.renderOffsetX;
                k.aj = d.renderOffsetY;
            }
            if (this.dh.xr != null && this.dh.xr.passCompleted != null) {
                this.dh.xr.passCompleted(c);
            }
        }
        dv() {
            this.dh.xr = null;
        }
        ds() {
            this.dh.xr = null;
            this.dh.xr = this.dh.xt;
        }
        dt() {
            this.dh.x8 = null;
        }
        dq() {
            this.dh.x8 = null;
            if (!isNaN_(this.e.hi) && this.e.hi != 1) {
                let a = BrushUtil.q(this.dh.ya, this.e.hi);
                this.dh.x8 = a;
            }
            else {
                this.dh.x8 = this.dh.ya;
            }
        }
        du() {
            this.dh.x9 = null;
        }
        dr() {
            this.dh.x9 = null;
            this.dh.x9 = this.dh.yb;
        }
        dp(a) {
            switch (a) {
                case "CircleMarkerTemplate":
                    this.dh.xr = this.dh.cy.py;
                    break;
                case "TriangleMarkerTemplate":
                    this.dh.xr = this.dh.cy.p7;
                    break;
                case "PyramidMarkerTemplate":
                    this.dh.xr = this.dh.cy.p4;
                    break;
                case "SquareMarkerTemplate":
                    this.dh.xr = this.dh.cy.p5;
                    break;
                case "DiamondMarkerTemplate":
                    this.dh.xr = this.dh.cy.pz;
                    break;
                case "PentagonMarkerTemplate":
                    this.dh.xr = this.dh.cy.p2;
                    break;
                case "HexagonMarkerTemplate":
                    this.dh.xr = this.dh.cy.p0;
                    break;
                case "TetragramMarkerTemplate":
                    this.dh.xr = this.dh.cy.p2;
                    break;
                case "PentagramMarkerTemplate":
                    this.dh.xr = this.dh.cy.p3;
                    break;
                case "HexagramMarkerTemplate":
                    this.dh.xr = this.dh.cy.p1;
                    break;
            }
        }
        dx() {
            for (let a of fromEnum(this.dn)) {
                a.ah = this.dh.xr;
            }
            this.as();
        }
        d5(a) {
            if (this.d4 == null) {
                this.d4 = new DataTemplateMeasureInfo();
                this.d4.context = this.k.h();
            }
            this.d4.width = a.width;
            this.d4.height = a.height;
            this.d4.data = a.content;
            let b = a.ah;
            if (b.measure != null) {
                b.measure(this.d4);
            }
            return new Size(1, this.d4.width, this.d4.height);
        }
        an(a) {
            let b = a;
            super.an(b);
            for (let c of fromEnum(this.di.c)) {
                let d = this.di.item(c);
                if (d._visibility != 1) {
                    let e = typeCast(ScatterPolygonSeries.$, this.e);
                    let f = this.e.a9.getMarkerVisualData(e, d, e.xr);
                    b.markerShapes.add(typeCast(MarkerVisualData.$, f));
                }
            }
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.e.a7.a$r(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.dh.title + "</span><br/>";
            a += "</div>";
            return a;
        }
    }
    ScatterPolygonSeriesView.$t = /*@__PURE__*/ markType(ScatterPolygonSeriesView, 'ScatterPolygonSeriesView', ShapeSeriesViewBase.$);
    return ScatterPolygonSeriesView;
})();
